//program quartet-method-3.cpp
/****************************/
/* S(T)0.85ƂȂ܂ő  */
/* ̂Ƃcount\      */
/****************************/
#include<stdlib.h>
#include<iostream>
#include<fstream>
#include<time.h>
#include<LEDA/graphics/graphwin.h>
#include<LEDA/graph/graph.h>
//#include<LEDA/graph/templates/shortest_path.h/>
#include<LEDA/graph/graph_alg.h>
#include<LEDA/graph/node_pq.h>
#include<LEDA/core/array.h>
#include <sys/types.h>
#include <sys/stat.h>
#define SIZE 1000
#define N 56

using namespace leda;
using namespace std;

void random_tree(graph& G,int n,node leaf[SIZE],node in_n[SIZE],edge e[SIZE]);
void copy_G(const graph& d_G,graph& G,int n,const node d_leaf[SIZE],node leaf[SIZE],const node d_in_n[SIZE],node in_n[SIZE],const edge d_e[SIZE],edge e[SIZE]);
void leaf_swap(graph& G,int n,node leaf[SIZE],node in_n[SIZE],edge e[SIZE]);
void subtree_swap(graph& G,int n,node in_n[SIZE],edge e[SIZE]);
void trancefer(graph& G,int n,edge e[SIZE]);
double loop(graph& G,int n,double dis[SIZE][SIZE]);
double quartet_cost(graph& G,int n,double dis[SIZE][SIZE],int a,int b,int c,int d);
double min_cost(double dis[SIZE][SIZE],int n);
double max_cost(double dis[SIZE][SIZE],int n);


int main(void){

  char hougen_name[N][N]={0};
  char filename[SIZE][SIZE]={0};
  double dis[SIZE][SIZE]={0};
  double min,max,max_ST,q_cost[3]={0},G_cost,G_ST,ST[3]={0};
  int i,j; //JEgpϐ
  int shuffle;
  int count=0;

  srand((unsigned)time(NULL)); /**/

  ifstream fin("quartet_fileout");
  if(!fin) return 1;

  for(i=0;i<N;i++){
    for(j=0;j<N;j++){
      if(i==j){
        //cout << dis[i][j] <<' ';
      } else{
        fin>>hougen_name[0];
	fin>>hougen_name[0];
	fin>>dis[i][j];
        //cout << dis[i][j] <<' ';
      }
    }
    //putchar('\n');
  }
  fin.close();
  
  GRAPH<char,double> G,d_G,d1_G,d2_G;
  GraphWin gw(G,800,800,"sekine-quartet-EUC");
  G.make_undirected();
  gw.set_edge_direction(undirected_edge);
  
  node leaf[N]; //datanode^̔z
  node in_n[N-2]; //inner nodenode^̔z
  node d_leaf[N]; //datanode^̔z _~[
  node d_in_n[N-2]; //inner nodenode^̔z _~[
  
  node d1_leaf[N],d2_leaf[N];
  node d1_in_n[N-2],d2_in_n[N-2];
  
  edge e[2*N-3];
  edge d_e[2*N-3],d1_e[2*N-3],d2_e[2*N-3];
  
  random_tree(G,N,leaf,in_n,e);
  
  min=min_cost(dis,N);
  max=max_cost(dis,N);
  
  /* ***make dummy*** */
  
  copy_G(G,d_G,N,leaf,d_leaf,in_n,d_in_n,e,d_e);
  copy_G(G,d1_G,N,leaf,d1_leaf,in_n,d1_in_n,e,d1_e);
  copy_G(G,d2_G,N,leaf,d2_leaf,in_n,d2_in_n,e,d2_e);
  
  
  G_cost=loop(G,N,dis);
  G_ST=(G_cost-max) / (min-max);
  max_ST=G_ST;
  
  /* *****tranceformation***** */
  
  do{
    leaf_swap(d_G,N,d_leaf,d_in_n,d_e);
    q_cost[0]=loop(d_G,N,dis);
    ST[0]=(q_cost[0]-max) / (min-max);
    
    //cout<<1<<endl;
    
    subtree_swap(d1_G,N,d1_in_n,d1_e);
    q_cost[1]=loop(d1_G,N,dis);
    ST[1]=(q_cost[1]-max) / (min-max);
    
    //cout<<2<<endl;
    
    trancefer(d2_G,N,d2_e);
    q_cost[2]=loop(d2_G,N,dis);
    ST[2]=(q_cost[2]-max) / (min-max);
    
    //cout<<3<<endl;
    
    for(i=0;i<3;i++){
      if(max_ST<ST[i]){
	max_ST=ST[i];
      }
    }
    
    if(max_ST==ST[0]){
      copy_G(d_G,G,N,d_leaf,leaf,d_in_n,in_n,d_e,e);
      //cout << "tree T's S(T):" << max_ST << endl;
    }
    else if(max_ST==ST[1]){
      copy_G(d1_G,G,N,d1_leaf,leaf,d1_in_n,in_n,d1_e,e);
      //cout << "tree T's S(T):" << max_ST << endl;
    }
    else if(max_ST==ST[2]){
      copy_G(d2_G,G,N,d2_leaf,leaf,d2_in_n,in_n,d2_e,e);
      //cout << "tree T's S(T):" << max_ST << endl;
    }
    else{
      copy_G(G,d_G,N,leaf,d_leaf,in_n,d_in_n,e,d_e);
      copy_G(G,d1_G,N,leaf,d1_leaf,in_n,d1_in_n,e,d1_e);
      copy_G(G,d2_G,N,leaf,d2_leaf,in_n,d2_in_n,e,d2_e);
    }
    
    /*if(count==0){
      gw.set_graph(G);
      
      ifstream f1_in("filename_v16");
      if(!f1_in) return 1;
      
      for(i=0;i<N;i++){
      f1_in >> hougen_name[i];
      gw.set_label(leaf[i],hougen_name[i]);      
      }
      f1_in.close();
      
      node v;
      forall_nodes(v,G){
      if(index(v)<N){
      gw.set_color(v,ivory);
      gw.set_shape(v,ellipse_node);
      gw.set_width(v,90);
      gw.set_height(v,20);
      }else{
      gw.set_color(v,grey1);
      gw.set_width(v,8);
      gw.set_height(v,8);
      }
      }
      
      gw.display();
      gw.edit();
      }
    */
    count++;
    
    //cout<<"count:"<<count<<endl;
    
  }while(max_ST<0.85);
  
  
  
  /* *****result***** */
  
  //cout << "data:" << N << endl;
  //cout << "max cost:" << max << endl;
  //cout << "min cost:" << min << endl;
  //cout << "Graph G's cost:" << G_cost << endl;
  //cout << "Graph G's S(T):" << max_ST << endl;
  //cout << "trancefer:" << count << endl;
  
  gw.set_graph(G);
  
  ifstream f_in("filename");
  if(!f_in) return 1;
  
  for(i=0;i<N;i++){
    f_in >> hougen_name[i];
    gw.set_label(leaf[i],hougen_name[i]);  
    gw.set_shape(leaf[i],rectangle_node);

     //***************nɂĂ̐F*****************

    
    if(strcmp(hougen_name[i],"hokkaido1")==0 || strcmp(hougen_name[i],"hokkaido2")==0)
      gw.set_color(leaf[i],red);
    //G.set_color(leaf[i],red);
    else if(strcmp(hougen_name[i],"aomori")==0 || strcmp(hougen_name[i],"iwate1") ==0 || strcmp(hougen_name[i],"iwate2")==0 || strcmp(hougen_name[i],"akita")==0 || strcmp(hougen_name[i],"miyagi")==0 || strcmp(hougen_name[i],"fukushima")==0 || strcmp(hougen_name[i],"yamagata")==0 )
      gw.set_color(leaf[i],green);
    //G.set_color(leaf[i],green);
    else if(strcmp(hougen_name[i],"tochigi")==0 || strcmp(hougen_name[i],"gunma")==0 || strcmp(hougen_name[i],"ibaraki")==0 || strcmp(hougen_name[i],"chiba1")==0 || strcmp(hougen_name[i],"chiba2")==0 || strcmp(hougen_name[i],"tokyo")==0 || strcmp(hougen_name[i],"kanagawa")==0 || strcmp(hougen_name[i],"nhk")==0)
      gw.set_color(leaf[i],blue);
    //G.set_color(leaf[i],blue);
    else if(strcmp(hougen_name[i],"aichi")==0 || strcmp(hougen_name[i],"shizuoka1")==0 || strcmp(hougen_name[i],"shizuoka2")==0 || strcmp(hougen_name[i],"nagano2")==0 || strcmp(hougen_name[i],"nigata1")==0 || strcmp(hougen_name[i],"nigata2")==0 || strcmp(hougen_name[i],"toyama")==0 || strcmp(hougen_name[i],"gifu")==0 || strcmp(hougen_name[i],"ishikawa")==0 || strcmp(hougen_name[i],"yamanashi")==0 || strcmp(hougen_name[i],"nagano1")==0)
      gw.set_color(leaf[i],yellow);
    //G.set_color(leaf[i],yellow);
    else if(strcmp(hougen_name[i],"kyoto")==0 || strcmp(hougen_name[i],"hyogo1")==0 || strcmp(hougen_name[i],"hyogo2")==0 || strcmp(hougen_name[i],"osaka")==0 || strcmp(hougen_name[i],"wakayama")==0 || strcmp(hougen_name[i],"nara")==0 || strcmp(hougen_name[i],"mie")==0)
      gw.set_color(leaf[i],pink);
    //G.set_color(leaf[i],pink);
    else if(strcmp(hougen_name[i],"hiroshima")==0 || strcmp(hougen_name[i],"shimane")==0 || strcmp(hougen_name[i],"okayama")==0 || strcmp(hougen_name[i],"yamaguchi")==0)
      gw.set_color(leaf[i],orange);
    //G.set_color(leaf[i],orange);
    else if(strcmp(hougen_name[i],"kouchi1")==0 || strcmp(hougen_name[i],"kouchi2")==0 || strcmp(hougen_name[i],"kagawa1")==0 || strcmp(hougen_name[i],"kagawa2")==0 || strcmp(hougen_name[i],"tokushima")==0 || strcmp(hougen_name[i],"ehime")==0)
      gw.set_color(leaf[i],violet);
    //G.set_color(leaf[i],violet);
    else if(strcmp(hougen_name[i],"fukuoka")==0 || strcmp(hougen_name[i],"saga")==0 || strcmp(hougen_name[i],"kumamoto1")==0 || strcmp(hougen_name[i],"kumamoto2")==0 || strcmp(hougen_name[i],"oita")==0 || strcmp(hougen_name[i],"miyazaki")==0 || strcmp(hougen_name[i],"nagasaki1")==0 || strcmp(hougen_name[i],"nagasaki2")==0 || strcmp(hougen_name[i],"kagoshima")==0)
      gw.set_color(leaf[i],cyan);
    //G.set_color(leaf[i],cyan);
    else if(strcmp(hougen_name[i],"nakijin")==0 || strcmp(hougen_name[i],"naha")==0)
      gw.set_color(leaf[i],ivory);
    //G.set_color(leaf[i],ivory);
    
  }

  f_in.close();
    
  node w;
  forall_nodes(w,G){
    if(G.degree(w)==3){
      gw.set_color(w,pink);
      gw.set_width(w,2);
      gw.set_height(w,2);
    } else{
      gw.set_shape(w,rectangle_node);
      gw.set_width(w,45);
      gw.set_height(w,15);
    }
  }
  gw.display();
  gw.edit();
  
  
  return(0);
}

void random_tree(graph& G,int n,node leaf[],node in_n[],edge e[]){
  
  int i,j,m;
  int deg,ed;
  int a,b,c;

  for(i=0;i<n;i++){ //OtGnode
    leaf[i]=G.new_node();
  }

  for(i=0;i<n-2;i++){ //OtGnode
    in_n[i]=G.new_node();
  }


  for(j=0;j<n/2;j++){ //subtree

    while(true){
      a=rand()%n;
      b=rand()%n;
      c=rand()%(n-2);

      if(a!=b){//t̂̂łȂASĂnode̎0̂Ƃ邱Ƃł
	if(G.degree(leaf[a])==0 && G.degree(leaf[b])==0 && G.degree(in_n[c])==0){
	  break;
	}
      }
    }

    m=n/2;
    e[j]=G.new_edge(in_n[c],leaf[a]);
    e[j+m]=G.new_edge(in_n[c],leaf[b]);

    ed=j+m+1;
  }

  do{
    m=0;

    if(n<=4)
      break;

    while(true){ //0inner nodeT
      a=rand()%(n-2);
      if(G.degree(in_n[a])==0){
	break;
      }
    }

    while(true){ //2inner nodeT
      b=rand()%(n-2);
      if(G.degree(in_n[b])==2){
	break;
      }
    }

    while(true){ //2inner nodeT
      c=rand()%(n-2);
      if(G.degree(in_n[c])==2 && c != b){
	break;
      }
    }

    e[ed]=G.new_edge(in_n[a],in_n[b]);
    e[ed+1]=G.new_edge(in_n[a],in_n[c]);
    ed=ed+2;

    for(j=0;j<n-2;j++){ //0inner node邩ǂ𔻒

      deg=G.degree(in_n[j]);
  
      if(deg==0){
	m=1;
      }
    }

  }while(m==1); //0inner node葱
 
  if(n%2==0){ //t̐Ȃ΁A2inner nodem
    for(i=0;i<n-2;i++){
      if(G.degree(in_n[i])==2){
	a=i;
	break;
      }
    }
    for(i=a+1;i<n-2;i++){
      if(G.degree(in_n[i])==2){
	b=i;
	break;
      }
    }
    e[ed]=G.new_edge(in_n[a],in_n[b]);

  }else{ //t̐Ȃ΁A0̗tƎ2inner node
    for(i=0;i<n;i++){
      if(G.degree(leaf[i])==0){
	a=i;
	break;
      }
    }
    for(i=0;i<n-2;i++){
      if(G.degree(in_n[i])==2){
	b=i;
	break;
      }
    }
    e[ed]=G.new_edge(in_n[b],leaf[a]);
  }

}

void copy_G(const graph& d_G,graph& G,int n,const node d_leaf[SIZE],node leaf[SIZE],const node d_in_n[SIZE],node in_n[SIZE],const edge d_e[SIZE],edge e[SIZE]){

  G=d_G;
  node w;
  forall_nodes(w,G){
    if(index(w)<n){
    leaf[index(w)]=w;
    }else{
    in_n[index(w)-n]=w;
    }
  }
  edge eg;
  forall_edges(eg,G){
    e[index(eg)]=eg;
  }

}

void leaf_swap(graph& G,int n,node leaf[],node in_n[],edge e[]){
  /* **********leaf swap********** */
  
  int a,b;

  a=rand()%n; //tI
  do{
    b=rand()%n;
  }while(a==b);

  edge_array<int> cost(G,1);
  node_array<int> dist(G,MAXINT);
  node_array<edge> pred(G);

  DIJKSTRA(G,leaf[a],cost,dist,pred);

  node v,u;
  edge eg,eg_a,eg_b;
  forall_nodes(v,G){

    if(v==leaf[b]){
      eg_b=pred[v];
      u=v;
      while(eg=pred[u]){
	if(u==G.source(eg)){
	  u=G.target(eg);
	}else{
	  u=G.source(eg);
	}
	eg_a=eg;
      }
    }
  }

  node ch_na,ch_nb; //ꂼ̐ڑnode
  if(leaf[a]==source(eg_a)){
    ch_na=target(eg_a);
  }else{
    ch_na=source(eg_a);
  }
  
  if(leaf[b]==source(eg_b)){
    ch_nb=target(eg_b);
  }else{
    ch_nb=source(eg_b);
  }

  G.del_edge(eg_a);
  G.del_edge(eg_b);
  
  e[index(eg_a)]=G.new_edge(ch_nb,leaf[a]);
  e[index(eg_b)]=G.new_edge(ch_na,leaf[b]);
  
  /* **********end********** */

}

void subtree_swap(graph& G,int n,node in_n[],edge e[]){
  /* **********subtree swap********** */  
  int a,b;

  a=rand()%(n-2); //inner nodeI
  do{
    b=rand()%(n-2);
  }while(a==b);

  edge_array<int> cost(G,1);
  node_array<int> dist(G,MAXINT);
  node_array<edge> pred(G);

  DIJKSTRA(G,in_n[a],cost,dist,pred);

  node v,u;
  edge eg,eg_a,eg_b;
  forall_nodes(v,G){

    if(v==in_n[b]){
      eg_b=pred[v];
      u=v;
      while(eg=pred[u]){
	if(u==G.source(eg)){
	  u=G.target(eg);
	}else{
	  u=G.source(eg);
	}
	eg_a=eg;
      }
    }
  }

  if(dist[in_n[b]]>2){

    node ch_na,ch_nb;
    if(in_n[a]==source(eg_a)){
      ch_na=target(eg_a);
    }else{
      ch_na=source(eg_a);
    }
    
    if(in_n[b]==source(eg_b)){
      ch_nb=target(eg_b);
    }else{
      ch_nb=source(eg_b);
    }
    
    G.del_edge(eg_a);
    G.del_edge(eg_b);
    
    e[index(eg_a)]=G.new_edge(ch_nb,in_n[a]);
    e[index(eg_b)]=G.new_edge(ch_na,in_n[b]);

  }
  /*  **********end********** */
}

void trancefer(graph& G,int n,edge e[SIZE]){
  /* **********trancefer********** */  
  int a,b;

  a=rand()%(2*n-2);
  do{
    b=rand()%(2*n-2);
  }while(a==b || (a<n && b<n));
  
  edge_array<int> cost(G,1);
  node_array<int> dist(G,MAXINT);
  node_array<edge> pred(G);
  
  node na,nb,nd;
  
  forall_nodes(nd,G){
    if(index(nd)==a){
      na=nd;
    }else if(index(nd)==b){
      nb=nd;
    }
  }

  DIJKSTRA(G,na,cost,dist,pred);

  node v,u;
  edge eg;
  edge eg_a,eg_b;
  forall_nodes(v,G){
    if(v==nb){
      eg_b=pred[v];
      u=v;
      while(eg=pred[u]){
	if(u==G.source(eg)){
	  u=G.target(eg);
	}else{
	  u=G.source(eg);
	}
	eg_a=eg;
      }
    }
  }


  if(dist[nb]>2){
    node a_adj;
    if(na==source(eg_a)){
      a_adj=target(eg_a);
    }else{
      a_adj=source(eg_a);
    }

    G.del_edge(eg_a);

    edge adj_1,adj_2;
    adj_1=G.first_adj_edge(a_adj);
    adj_2=G.last_adj_edge(a_adj);
  
    G.del_edge(adj_1);
    G.del_edge(adj_2);

    if(a_adj==source(adj_1)){
      if(a_adj==source(adj_2)){
	e[index(adj_2)]=G.new_edge(target(adj_1),target(adj_2));
      }else{
	e[index(adj_2)]=G.new_edge(target(adj_1),source(adj_2));
      }
    }else{
      if(a_adj==source(adj_2)){
	e[index(adj_2)]=G.new_edge(source(adj_1),target(adj_2));
      }else{
	e[index(adj_2)]=G.new_edge(source(adj_1),source(adj_2));
      }
    }

    node b_adj;
    if(nb==source(eg_b)){
      b_adj=target(eg_b);
    }else{
      b_adj=source(eg_b);
    }

    G.del_edge(eg_b);
    e[index(eg_a)]=G.new_edge(a_adj,b_adj);
    e[index(eg_b)]=G.new_edge(a_adj,na); 
    e[index(adj_1)]=G.new_edge(a_adj,nb);

    /* **********end********** */ 
  }
}

double loop(graph& G,int n,double dis[SIZE][SIZE]){
  int a,b,c,d;
  double cost=0;

  for(a=0;a<n-3;a++){
    for(b=a+1;b<n-2;b++){
      for(c=b+1;c<n-1;c++){
	for(d=c+1;d<n;d++){
	  cost=cost+quartet_cost(G,n,dis,a,b,c,d);
	}
      }
    }
  }

  return(cost);
}

double quartet_cost(graph& G,int n,double dis[SIZE][SIZE],int a,int b,int c,int d){
  int a_to[SIZE]={0};
  int d_to[SIZE]={0};
  int i=0,j=0;
  int x=0,y=0;
  double q_cost;
  edge_array<int> cost(G,1);
  node_array<int> dist_a(G,MAXINT);
  node_array<int> dist_d(G,MAXINT);
  node_array<edge> pred_a(G);
  node_array<edge> pred_d(G);

  node v,na,nb,nc,nd;
  forall_nodes(v,G){
    if(index(v)==a){
      na=v;
    }else if(index(v)==b){
      nb=v;
    }else if(index(v)==c){
      nc=v;
    }else if(index(v)==d){
      nd=v;
    }
  }
  DIJKSTRA(G,na,cost,dist_a,pred_a);
  DIJKSTRA(G,nd,cost,dist_d,pred_d);
  
  edge e;
  node u,w;
  
  /**************Check quartet (ab|cd)***************/
  
  forall_nodes(w,G){
    if(w==nb){
      u=w;
      while(e=pred_a[u]){
	if(u==G.source(e)){
	  u=G.target(e);
	}else{
	  u=G.source(e);
	}
	a_to[i]=index(u);
	i++;
      }
    }else if(w==nc){
      u=w;
      while(e=pred_d[u]){
	if(u==G.source(e)){
	  u=G.target(e);
	}else{
	  u=G.source(e);
	}
	d_to[j]=index(u);
	j++;
      }
    }
  }
  
  for(i=0;i<dist_a[nb];i++){
    for(j=0;j<dist_d[nc];j++){
      if(a_to[i]==d_to[j]){
	x=1;
	break;
      }
    }
    if(x){break;}
  }

  /**************Check quartet (ab|cd)***************/
  i=0;
  j=0;
  /**************Check quartet (ac|bd)***************/

  forall_nodes(w,G){
    if(w==nc){
      u=w;
      while(e=pred_a[u]){
	if(u==G.source(e)){
	  u=G.target(e);
	}else{
	  u=G.source(e);
	}
	a_to[i]=index(u);
	i++;
      }
    }else if(w==nb){
      u=w;
      while(e=pred_d[u]){
	if(u==G.source(e)){
	  u=G.target(e);
	}else{
	  u=G.source(e);
	}
	d_to[j]=index(u);
	j++;
      }
    }
  }

  for(i=0;i<dist_a[nc];i++){
    for(j=0;j<dist_d[nb];j++){
      if(a_to[i]==d_to[j]){
	y=1;
	break;
      }
    }
    if(y){break;}
  }

  /**************Check quartet (ac|bd)***************/

  if(x==1 && y==1){
    q_cost=dis[a][d]+dis[b][c];
  }else if(x==0){
    q_cost=dis[a][b]+dis[c][d];
  }else if(y==0){
    q_cost=dis[a][c]+dis[b][d];
  }else{
    cout << "Error!!" << endl;
  }

  return(q_cost);
}
double min_cost(double dis[][SIZE],int n){
  int i,j,k,l;
  double min=0,tmp;

  for(i=0;i<n-3;i++){
    for(j=i+1;j<n-2;j++){
      for(k=j+1;k<n-1;k++){
	for(l=k+1;l<n;l++){
	  tmp=dis[i][j]+dis[k][l];
	  if(tmp>dis[i][k]+dis[j][l]){
	    tmp=dis[i][k]+dis[j][l];
	  }
	  if(tmp>dis[i][l]+dis[j][k]){
	    tmp=dis[i][l]+dis[j][k];
	  }
	  min=min+tmp;
	}
      }
    }
  }
  return(min);
}
double max_cost(double dis[][SIZE],int n){
  int i,j,k,l;
  double max=0,tmp;

  for(i=0;i<n-3;i++){
    for(j=i+1;j<n-2;j++){
      for(k=j+1;k<n-1;k++){
	for(l=k+1;l<n;l++){
	  tmp=dis[i][j]+dis[k][l];
	  if(tmp<dis[i][k]+dis[j][l]){
	    tmp=dis[i][k]+dis[j][l];
	  }
	  if(tmp<dis[i][l]+dis[j][k]){
	    tmp=dis[i][l]+dis[j][k];
	  }
	  max=max+tmp;
	}
      }
    }
  }
  return(max);
}

